org.apache.hc.client5.http.nio

## Interface AsyncClientConnectionOperator

    @Contract(threading=STATELESS)
    @Internal
    public interface AsyncClientConnectionOperator

Connection operator that performs connection connect and upgrade operations.

Since:
  5.0

### Method Summary

Methods
`Future<ManagedAsyncClientConnection>` `connect(ConnectionInitiator connectionInitiator, HttpHost host, SocketAddress localAddress, Timeout connectTimeout, Object attachment, FutureCallback<ManagedAsyncClientConnection> callback)` Initiates operation to create a connection to the remote endpoint using the provided `ConnectionInitiator`.
`void` `upgrade(ManagedAsyncClientConnection conn, HttpHost host, Object attachment)` Upgrades transport security of the given managed connection by using the TLS security protocol.

### Method Detail

#### connect

    Future<ManagedAsyncClientConnection> connect(ConnectionInitiator connectionInitiator,
                                               HttpHost host,
                                               SocketAddress localAddress,
                                               Timeout connectTimeout,
                                               Object attachment,
                                               FutureCallback<ManagedAsyncClientConnection> callback)

Initiates operation to create a connection to the remote endpoint using the provided `ConnectionInitiator`.

Parameters:
  `connectionInitiator` - the connection initiator.
  `host` - the address of the opposite endpoint.
  `localAddress` - the address of the local endpoint.
  `connectTimeout` - the timeout of the connect operation.
  `attachment` - the attachment, which can be any object representing custom parameter of the operation.
  `callback` - the future result callback.

#### upgrade

    void upgrade(ManagedAsyncClientConnection conn,
               HttpHost host,
               Object attachment)

Upgrades transport security of the given managed connection by using the TLS security protocol.

Parameters:
  `conn` - the managed connection.
  `host` - the address of the opposite endpoint with TLS security.
  `attachment` - the attachment, which can be any object representing custom parameter of the operation.